<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Assembly Slides</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/white.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<!-- UGLY inline CSS but using this div to test Unclassified banner -->
		<!-- <div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div> -->
		<div class="reveal">
			<div class="slides">
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>Assembly</h1>
					</section>
					<section>
						<h2>Assembly Overview</h2>
						<ul>
							<li><b>What is Assembly?</b></li>
							<li><b>Low-level programming language</b></li>
							<li><b>Communicate with microprocessor</b></li>
							<li><b>An almost one-tone correspondece with machine code</b></li>
						</ul>
					</section>
					<section>
					    <img src="/assets/asm1.JPG" alt="asm1">
					</section>
					<section>
					    <img src="/assets/asm2.JPG" alt="asm2">
					</section>
					<section>
					<img src="/assets/asm3.JPG" alt="asm3">

					</section>
					<section>
					<img src="/assets/asm4.png" alt="asm2">

					</section>
					<section>
					    <h2>Intel Architecture</h2>
							<li>IA-32</li>
							<li>IA-64</li>
					</section>
					<section>
						<h2>Why IA-32</h2>
						<li>Large number of machines out there still run IA-32</li>
						<li>Logical progression to IA-64</li>
						<li>Shellcoding, Encoders, Decoders, Packers etc... Implementation difference</li>
					</section>
					<section>
						<h2>Exercise: Understanding your CPU</h2>
						<li>How do you know if you are on a 32/64 bit cpu?</li>
						<li> How do you know your CPU's additional capabilities such as FPU, MMX, SSE, SSE2, etc..?</li>

					</section>
					
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>IA-32</h2>
					
					</section>		
				</section>
				<section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
					<h2>IA-32 Architecture</h2>
					<h3>System Organization Basics</h3>
					<img src="/assets/asm5.JPG" alt="asm5">
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
					</aside>
				</section>
				<section>
					<img src="/assets/asm6.JPG" alt="asm6">
				</section>
				<section>
				<img src="/assets/asm6.JPG" alt="asm6">
				</section>
				<section>
				<img src="/assets/asm7.JPG" alt="asm7">
				</section>
				<section>
				<img src="/assets/asm8.JPG" alt="asm8">
				</section>
				<section>
				<img src="/assets/asm9.JPG" alt="asm9">
				</section>
				<section>
					<h2>GPR COMMON FUNCTIONALITY</h2>
				<img src="/assets/asm10.JPG" alt="asm10">
				</section>
				<section>
					<h2>Segment Registers</h2>
				<img src="/assets/asm11.JPG" alt="asm11">
				</section>
				<section>
					<h2>EFLAGS Register</h2>
					<img src="/assets/asm12.JPG" alt="asm12">
				
				</section>
				<section>
				<h2>EIP</h2>
				<li>Instruction pointer</li>
				<li>Holy grail for shellcoding, Exploit Research etc..</li>
				<img src="/assets/asm13.JPG" alt="asm13">
				</section>
				<section>
				<h2>Floating Point unit(FPU)</h2>
				<h2>SIMD</h2>

				</section>
				<section>
				<h2>Additional registers</h2>
				<li>MMX</li>
				<li>XMM</li>
				
				</section>



				<!-- FILL WITH SECTIONS (SLIDES) -->
			

				<section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
				<h2>Assembly Demos</h2>
				<li>Using GDB</li>
				<li>Data Types</li>
				<li>Moving Data</li>
				<li>Stack</li>
				<li>Arithmetic Instructions</li>
				<li>Logical Instructions</li>
				<li>Control Instructions</li>
				<li>Procedures</li>

				</section>
				

				
				<section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
					
				</section>
				<section>
				
				</section>
				<section>
				
				</section>
				<section>

				</section>
				<section>
				
				</section>
				<section>
				
				</section>
				<section>

				</section>
				<section>
				
				</section>
				<section>
				
				</section>
				<section>

				</section>
			</div>
		</div>
		<!-- This footer doesn't work. Need to play with CSS -->
		<!-- <footer style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer> -->
			
		<!-- DO NOT TOUCH -->
		<script src="js/reveal.js"></script>

		<script>
			Reveal.initialize({
				slideNumber: true,
				hash: true,
				menu: {
					side: 'left',
					width: 'normal',
					numbers: true,
					titleSelector: 'h1, h2, h3, h4, h5, h6',
					useTextContentForMissingTitles: false,
					hideMissingTitles: false,
					markers: true,
					custom: false,
					themes: true,
					themesPath: 'css/theme/',
					transitions: true,
					openButton: true,
					openSlideNumber: true,
					keyboard: true,
					sticky: true,
					autoOpen: true,
					delayInit: false,
					openOnInit: false,
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
			Reveal.configure({slideNumber: true})
		</script>
	</body>
</html>
